package main
import( "fmt"; "os"; "strconv"; "runtime";
        "time"; "sync"; "sync/atomic"; "math" )

func main() {
   секунды, потоки := 1, 2             // интервал выполнения и число потоков
   debug := false
   var err error 
   if len( os.Args ) > 1 {
      потоки, err = strconv.Atoi( os.Args[ 1 ] )
      if err != nil {
         fmt.Printf( "запуск: %s [потоков] [[-]секунд]\n", os.Args[ 0 ] )
         os.Exit( 1 )
      } 
	  if len( os.Args ) > 2 {
         секунды, err = strconv.Atoi( os.Args[ 2 ] )
         if err != nil { 
            fmt.Printf( "запуск: %s [потоков] [[-]секунд]\n", os.Args[ 0 ] )
            os.Exit( 1 )
         } 
         if секунды < 0 {              // признак отладочной диагностики
            секунды = -секунды; debug = true
		 }
      }
   }
   runtime.GOMAXPROCS( потоки )        // число разрешённых процессоров 
   if( debug ) {
      fmt.Printf( "число потоков %v\n", потоки );
      fmt.Printf( "процессоров в системе %v/%v\n",
                  runtime.NumCPU(), runtime.GOMAXPROCS( -1 ) )
   }
   res := make( [] uint64, потоки )    // массив результатов
   var wg sync.WaitGroup               // WaitGroup - барьер завершения
   var finish uint32 = 0
   for i := range res {
      go func( j int ) {               // функция сопрограммы 
         var counter uint64 = 0
	     wg.Add( 1 )
         defer wg.Done()
         defer func() {                // завершение: возврат значения
            res[ j ] = counter
         } ()
         for ; finish == 0; {
            counter++
            runtime.Gosched()          // дать другим работать
         }
      } ( i )
   }
   time.Sleep( time.Duration( секунды ) * time.Second ) // наносекунды
   atomic.StoreUint32( &finish, 1 )
   wg.Wait()                           // ожидание завершения сопрограмм
   if debug {
	  for i := range res {
         fmt.Printf( "%v ", res[ i ] ) 
      }
      fmt.Printf( "\n" )    
   }
   var sum1, sum2, sq, md float64 = 0, 0, 0, 0
   for i := range res {
      md = float64( res[ i ] )
      sum1 += md
      sum2 += md * md
   } 
   md = sum1 / float64( потоки )                         // среднее
   sq = math.Sqrt( sum2 / float64( потоки ) - md * md )  // СКО
   fmt.Printf( "операций %.0f : %d * %.0f [+/-%.2f%%]\n",
               sum1, потоки, md, 100. * sq / md )
}
