#!/usr/bin/python
# -*- coding: utf-8 -*-
import os
import time
import sys
import signal
from multiprocessing import cpu_count, Value, Array
import math
# параллельные процессы - fork():

def handler( signum, frame ):               # обработчик сигнала SIGUSR1
    global finish
    finish = True

nthr = 2                                    # число параллельых процессов
sec = 1                                     # интервал выполнения
debug = False
finish = False                              # флаг завергшения
try :
    if len( sys.argv ) > 1 :
        nthr = int( sys.argv[ 1 ] )
        if len( sys.argv ) > 2 :
            sec = int( sys.argv[ 2 ] )
            if sec < 0 :                    # признак отладочной диагностики
                sec = -sec
                debug = True
except ValueError :
    print( 'запуск: python[3] {} [потоков] [[-]секунд]'.format( sys.argv[ 0 ] ) )
    sys.exit( 1 )
if( debug ) :
    print( 'число процессов {}'.format( nthr ) )
    print( 'число доступных процессоров {}'.format( cpu_count() ) )
counter = 0
childs = [] 
res = Array( 'i', range( nthr ) )           # массив результатов в shared memory
for i in range( nthr ) :                    # создание и запуск исполняющих процессов
    try :
        pid = os.fork();                    # запуск новых процессов 
    except :
        print( 'error: create child process' ); sys.exit( 33 )
    if pid == 0 :                           # порождённый процесс
        signal.signal( signal.SIGUSR1, handler )
        while not finish : counter += 1 
        res[ i ] = counter
        sys.exit( 0 )
    if pid > 0 :                            # родительский процесс
        childs.append( pid )
time.sleep( sec )
for pid in childs :  os.kill( pid, signal.SIGUSR1 )
for pid in childs : pid, status = os.wait() # ожидание завершения всех процессов
if debug :
    msg = ''
    for i in range( len( res ) ) : msg += '{} '.format( res[ i ] )
    print( '{}'.format( msg ) )
sum1, sum2, sq, md = 0.0, 0.0, 0.0, 0.0     # сбор статистики
for i in range( len( res ) ) :
    md = float( res[ i ] )
    sum1 += md
    sum2 += md * md;
md = sum1 / nthr;                           # среднее
sq = math.sqrt( sum2 / nthr - md * md );    # СКО
print( 'операций {:.0f} : {} * {:.0f} [+/-{:.2f}%]'
       .format( sum1 , nthr, md, 100. * sq / md ) )
sys.exit( 0 )
