#!/usr/bin/python -O
# -*- coding: utf-8 -*-
import sys
import time
try:
    import thread as thred
except ImportError:
    import _thread as thred
from multiprocessing import cpu_count
import math
# низкоуровневая _thread модель:

def RunCounter( arr, num ) :
    global wait, active, finish
    lock = thred.allocate_lock()         # блокировка доступа к числу активных потоков
    lock.acquire(); active += 1; lock.release()
    counter = 0
    while not finish : counter += 1
    lock.acquire(); active -= 1; lock.release()
    arr[ num ] = counter
    if 0 == active : wait.release()      # если это последний поток...
    return

nthr = 2                                 # число потоков
sec = 1                                  # интервал выполнения
debug = False
wait = thred.allocate_lock()             # блокировка ожидания завершения всех потоков
active = 0                               # число активно выполняющихся потоков
finish = False
try :
    if len( sys.argv ) > 1 :
        nthr = int( sys.argv[ 1 ] )
        if len( sys.argv ) > 2 :
            sec = int( sys.argv[ 2 ] )
            if sec < 0 :                 # признак отладочной диагностики
                sec = -sec
                debug = True
except ValueError :
    print( 'запуск: python[3] {} [потоков] [[-]секунд]'.format( sys.argv[ 0 ] ) )
    sys.exit( 1 )
if( debug ) :
    print( 'число потоков {}'.format( nthr ) )
    print( 'число доступных процессоров {}'.format( cpu_count() ) )
res = [ 0 for x in range( nthr ) ]       # результирующие счётчики
wait.acquire()                           # предварительный захват блокировки
for i in range( nthr ) :                 # запуск всех потоков
    thred.start_new_thread( RunCounter, ( res, i ) )
time.sleep( sec )
finish = True
wait.acquire()                           # ожидание завершения всех потоков
if debug :
    msg = ''
    for i in range( nthr ) :
        msg += '{} '.format( res[ i ] )
    print( '{}'.format( msg ) )
sum1, sum2, sq, md = 0.0, 0.0, 0.0, 0.0  # сбор статистики
for i in range( nthr ) :
    md = float( res[ i ] )
    sum1 += md
    sum2 += md * md;
md = sum1 / nthr;                        # среднее
sq = math.sqrt( sum2 / nthr - md * md ); # СКО
print( 'операций {:.0f} : {} * {:.0f} [+/-{:.2f}%]'
       .format( sum1 , nthr, md, 100. * sq / md ) )
sys.exit( 0 )
