import java.lang.Thread;

// модель с флагом завершения
class RunCounter extends Thread {
   private volatile static boolean finish = false; // флаг завершения
//   private static boolean finish = false;       // флаг завершения
   synchronized static void setFinal() { finish = true; };
//   synchronized static boolean getFinal() { return finish; } 
   private long counter;
   RunCounter() { counter = 0;  }
   public void run() {
//     while( !getFinal() ) counter++;
     while( !finish ) counter++;
   }
   long getCount() { return counter; }
}

public class ThreadSpeed {
   public static void main( String[] args ) {
      int nthr = 2,                             // число потоков
          sec = 1;                              // интервал выполнения
      boolean debug = false;
      try {
         if( args.length > 0 )
            nthr = new Integer( args[ 0 ] ).intValue();
         if( args.length > 1 ) {
            sec = new Integer( args[ 1 ] ).intValue();
            if( debug = sec < 0 )               // признак отладочной диагностики
               sec = -sec;
         }
      }
      catch( java.lang.NumberFormatException ex ) {
         System.out.println( "запуск: java ThreadSpeed [потоков] [[-]секунд]" );
         System.exit( 1 );
      }
      if( debug ) System.out.println( "число потоков " + nthr );
      RunCounter ar[] = new RunCounter[ nthr ];
      for( int i = 0; i < nthr; i++ ) ar[ i ] = new RunCounter();
      for( int i = 0; i < nthr; i++ ) ar[ i ].start();
      try { Thread.sleep( sec * 1000 ); }
      catch( InterruptedException ex ) {
         System.out.println( "ошибка ожидания " + " : " + ex.toString() );
      }
      RunCounter.setFinal();
      for( int i = 0; i < nthr; i++ )           // ожидаем завершения
         try {
            ar[ i ].join();
         }
         catch( InterruptedException ex ) {
            System.out.println( "ошибка потока " + i + " : " + ex.toString() );
         }
      if( debug )
         for( int i = 0; i < nthr; i++ )
            System.out.print( ar[ i ].getCount() + ( i == nthr - 1 ? "\n" : " " ) );
      double sum1 = 0, sum2 = 0, sq, md;        // сбор статистики
      for( int i = 0; i < nthr; i++ ) {
         md = ar[ i ].getCount();
         sum1 += md;
         sum2 += md * md;
      }
System.out.println( "sum1=" + sum1 + " sum2=" + sum2 );
      md = sum1 / nthr;                         // среднее
      sq = Math.sqrt( sum2 / nthr - md * md );  // СКО
      sum2 = ( (int)( 100. * sq / md ) * 100 ) / 100.;
System.out.println( "sq=" + sq / md );


      System.out.println( "операций " + (long)sum1 + " : " +
                          nthr + " * " + (long)md + " [+/-" +
                          sum2 + "%]" ); 

/*      System.out.println( "операций " + sum1 + " : " +
                          nthr + " * " + md + " [+/-" +
                          sum2 + "%]" );  */

   }
}
